/* Tabela TABLAYOUTIMP: TABELA DO LAYOUT DE IMPORTAO GENERICA*/
/* Descrio: A trigger insere registros na tabela LOGOPERAVND a partir de alteraes na tabela TABLAYOUTIMP */
/* Objetivo: Gerar um log que vai registrar as alteraes na TABLAYOUTIMP,
             utilizando a tabela de Logs de Operaes do VND*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_VND_TABLAYOUTIMP' AND
                 TYPE   = 'TR' 	               AND
	              U.UID  = O.UID           AND
	              U.NAME = USER)
DROP TRIGGER LOG_VND_TABLAYOUTIMP
GO


CREATE TRIGGER LOG_VND_TABLAYOUTIMP
ON TABLAYOUTIMP
FOR INSERT, UPDATE, DELETE
AS
  DECLARE @V_DSREMOTEADDR VARCHAR(15);
  DECLARE @V_DSREMOTEHOST VARCHAR(15);
  DECLARE @V_DSSERVERRDM  VARCHAR(20);
  DECLARE @V_DSSERVMETHOD VARCHAR(30);
  DECLARE @V_DSREMOTEOPER VARCHAR(12);
  DECLARE @V_DESC         VARCHAR(500);
  DECLARE @V_ITPESQ       VARCHAR(40);
  DECLARE @V_NMOPERADOR   VARCHAR(40);
  DECLARE @V_IDTIPOOPER   VARCHAR(1);

/*VARIVEIS DO CURSOR C_CURSOR*/

  DECLARE @V_ID_COMANDO    VARCHAR(1);

  DECLARE @V_NEW_CDLAYOUTIMP         varchar(10);
  DECLARE @V_NEW_NRSEQTABELAY        Varchar(10);
  DECLARE @V_NEW_NMTABELABD          varchar(30);               
  DECLARE @V_NEW_NRORDIMPLAY         varchar(5);
  DECLARE @V_NEW_NMARQLAYIMP         varchar(250);
            
  DECLARE @V_OLD_CDLAYOUTIMP         varchar(10);
  DECLARE @V_OLD_NRSEQTABELAY        Varchar(10);
  DECLARE @V_OLD_NMTABELABD          varchar(30);               
  DECLARE @V_OLD_NRORDIMPLAY         varchar(5);
  DECLARE @V_OLD_NMARQLAYIMP         varchar(250);            

BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/

   SET @V_DESC   = '';
   SET @V_ITPESQ     = '';
   SET @V_NMOPERADOR = '';
   SET @V_IDTIPOOPER = '';

   EXEC NMUSUARIO @P_NMUSUARIO = @V_NMOPERADOR OUTPUT;
   SET @V_NMOPERADOR = ISNULL(@V_NMOPERADOR, ' ');

   EXEC WEBTUNNING  @P_DSREMOTEADDR = @V_DSREMOTEADDR OUTPUT,
                    @P_DSREMOTEHOST = @V_DSREMOTEHOST OUTPUT,
                    @P_DSSERVERRDM  = @V_DSSERVERRDM OUTPUT,
                    @P_DSSERVMETHOD = @V_DSSERVMETHOD OUTPUT,
                    @P_DSREMOTEOPER = @V_DSREMOTEOPER OUTPUT;

   DECLARE C_CURSOR CURSOR FOR
     SELECT
     'D'   ID_COMANDO,
           NULL,NULL,NULL,NULL,NULL,
           CDLAYOUTIMP,
           NRSEQTABELAY,
           NMTABELABD,
           NRORDIMPLAY,
           NMARQLAYIMP
     FROM
           DELETED
     WHERE     
           CDLAYOUTIMP + NRSEQTABELAY NOT IN (SELECT CDLAYOUTIMP + NRSEQTABELAY FROM INSERTED)
     UNION ALL

     SELECT
     'U'   IDCOMANDO,
           INSERTED.CDLAYOUTIMP,
           INSERTED.NRSEQTABELAY,
           INSERTED.NMTABELABD,
           INSERTED.NRORDIMPLAY,
           INSERTED.NMARQLAYIMP,
           DELETED.CDLAYOUTIMP,
           DELETED.NRSEQTABELAY,
           DELETED.NMTABELABD,
           DELETED.NRORDIMPLAY,
           DELETED.NMARQLAYIMP
     FROM
           INSERTED,
           DELETED
     WHERE     
           INSERTED.CDLAYOUTIMP  =  DELETED.CDLAYOUTIMP AND
           INSERTED.NRSEQTABELAY =  DELETED.NRSEQTABELAY
     UNION ALL

     SELECT
     'I'   IDCOMANDO,
           INSERTED.CDLAYOUTIMP,
           INSERTED.NRSEQTABELAY,
           INSERTED.NMTABELABD,
           INSERTED.NRORDIMPLAY,
           INSERTED.NMARQLAYIMP,
           NULL,NULL,NULL,NULL,NULL
     FROM
           INSERTED
     WHERE     
           CDLAYOUTIMP + NRSEQTABELAY NOT IN (SELECT CDLAYOUTIMP + NRSEQTABELAY FROM DELETED)

     OPEN C_CURSOR;
           FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                         @V_NEW_CDLAYOUTIMP,@V_NEW_NRSEQTABELAY,@V_NEW_NMTABELABD,@V_NEW_NRORDIMPLAY,@V_NEW_NMARQLAYIMP,
                                         @V_OLD_CDLAYOUTIMP,@V_OLD_NRSEQTABELAY,@V_OLD_NMTABELABD,@V_OLD_NRORDIMPLAY,@V_OLD_NMARQLAYIMP

    WHILE (@@FETCH_STATUS = 0) BEGIN
    
       IF @V_ID_COMANDO= 'U' /*UPDATE*/ BEGIN
		IF ISNULL(@V_NEW_CDLAYOUTIMP,'NULL') <> ISNULL(@V_OLD_CDLAYOUTIMP,'NULL') BEGIN
			SET @V_DESC   = 'Cd Layout Imp '    + ISNULL(@V_NEW_CDLAYOUTIMP,'' );
		END;
		IF ISNULL(@V_NEW_NRSEQTABELAY,'NULL') <> ISNULL(@V_OLD_NRSEQTABELAY,'NULL') BEGIN
            SET @V_DESC  = ISNULL(@V_DESC,'') + '  Nr Seq da Tabela ' + ISNULL(@V_NEW_NRSEQTABELAY,'');
		END;
		IF ISNULL(@V_NEW_NMTABELABD,'NULL') <> ISNULL(@V_OLD_NMTABELABD,'NULL') BEGIN
            SET @V_DESC  = ISNULL(@V_DESC,'') + '  NMTABELABD ' + ISNULL(@V_NEW_NMTABELABD,'' );
		END;
		IF ISNULL(@V_NEW_NRORDIMPLAY,'NULL') <> ISNULL(@V_OLD_NRORDIMPLAY,'NULL') BEGIN
            SET @V_DESC  = ISNULL(@V_DESC,'') + '  Nr Ordem da imp ' + ISNULL(@V_NEW_NRORDIMPLAY,'' );
		END;
		IF ISNULL(@V_NEW_NMARQLAYIMP,'NULL') <> ISNULL(@V_OLD_NMARQLAYIMP,'NULL') BEGIN
            SET @V_DESC  = ISNULL(@V_DESC,'') + '  Nm do Arquivo ' + ISNULL(@V_NEW_NMARQLAYIMP,'' );
		END;
          SET @V_IDTIPOOPER = '2';
       END;
       IF @V_ID_COMANDO= 'I' /*INSERO*/ BEGIN
          SET @V_DESC   = 'Cd Layout Imp '    + ISNULL(@V_NEW_CDLAYOUTIMP,'' )   + ' ' +
                      'Nr Seq da Tabela ' + ISNULL(@V_NEW_NRSEQTABELAY,'')   + ' ' +
                      'NMTABELABD'        + ISNULL(@V_NEW_NMTABELABD,''  )   + ' ' +
                      'Nr Ordem da imp '  + ISNULL(@V_NEW_NRORDIMPLAY,'' )   + ' ' +
                      'Nm do Arquivo '    + ISNULL(@V_NEW_NMARQLAYIMP,'' );
          SET @V_IDTIPOOPER = '1';
       END;
       IF @V_ID_COMANDO= 'D' /*DELEO*/  BEGIN
          SET @V_DESC   = 'Cd Layout Imp '    + ISNULL(@V_OLD_CDLAYOUTIMP,'' )   + ' ' +
                      'Nr Seq da Tabela ' + ISNULL(@V_OLD_NRSEQTABELAY,'')   + ' ' +
                      'NMTABELABD'        + ISNULL(@V_OLD_NMTABELABD,''  )   + ' ' +
                      'Nr Ordem da imp '  + ISNULL(@V_OLD_NRORDIMPLAY,'' )   + ' ' +
                      'Nm do Arquivo '    + ISNULL(@V_OLD_NMARQLAYIMP,'' ); 
          SET @V_IDTIPOOPER = '3';
       END;
       IF  (@V_IDTIPOOPER <> '') BEGIN
          IF @V_DESC IS NOT NULL BEGIN
             SET @V_ITPESQ =  ISNULL(@V_NEW_CDLAYOUTIMP + @V_NEW_NRSEQTABELAY ,@V_OLD_CDLAYOUTIMP + @V_OLD_NRSEQTABELAY );
             SET @V_DESC = SUBSTRING(@V_DESC, 1, 300);
             INSERT INTO LOGOPERAVND
                    (NMTABELAVND, DTOPERACAOVND, NMRESPOPERVND, IDTIPOOPERVND, DSOPERACAOVND,
                     CDPESQITEMVND, DSRDMUSUOPERVND, DSENDUSUOPERVND, DSNMUSUOPERVND, DSMETUSUOPERVND,
                     CDORESPOPERVND)
             VALUES ('TABLAYOUTIMP',GETDATE(), ISNULL(@V_NMOPERADOR,' '), @V_IDTIPOOPER, @V_DESC, @V_ITPESQ,
                     @V_DSSERVERRDM, @V_DSREMOTEADDR, @V_DSREMOTEHOST, @V_DSSERVMETHOD, @V_DSREMOTEOPER);
          END;
       END;
       FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                     @V_NEW_CDLAYOUTIMP,@V_NEW_NRSEQTABELAY,@V_NEW_NMTABELABD,@V_NEW_NRORDIMPLAY,@V_NEW_NMARQLAYIMP,
                                     @V_OLD_CDLAYOUTIMP,@V_OLD_NRSEQTABELAY,@V_OLD_NMTABELABD,@V_OLD_NRORDIMPLAY,@V_OLD_NMARQLAYIMP

    SET @V_DESC   = '';    
    END;
    CLOSE      C_CURSOR;
    DEALLOCATE C_CURSOR;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_VND_TABLAYOUTIMP','5.20.001';
GO
